
Redmine - Defect #3832

Git blame/annotate fails on moved files

2009-09-08 09:04 - Jiongliang Zhang

Status: Closed Start date: 2009-09-08

Priority: Normal Due date:  

Assignee: Jean-Philippe Lang % Done: 0%

Category: SCM Estimated time: 0.00 hour

Target version: 0.9.4   

Resolution: Fixed Affected version:  

Description

1. Error: The entry does not exist or can not be annotated, it happens at many files. And the files have so Chinese words, does it

because unicode or something?

But I really sure its exist.

Parameters: {"rev"=>"master", "action"=>"annotate", "id"=>"scm-test", "controller"=>"repositories"

, "path"=>["source", "engine", "engine", "engine.c"]}

Rendering template within layouts/base

Completed in 89ms (View: 15, DB: 9) | 500 Internal Server Error [http://172.25.78.117/projects/scm

-test/repository/revisions/master/annotate/source/engine/engine/engine.c]

2. Operation steps:

1. when I rename a directory "src" to "source" (git), no edit any files.

2. generate a commit object "ddddddd"(git),

3. press "Repository" (redmine),

4. press "ddddddd" revision,(redmine), but it shows the working tree fiels, like: files.txt

5. press "file.txt" link, then

6. error happen: The entry or revision was not found in the repository.

Associated revisions

Revision 3513 - 2010-02-28 13:09 - Jean-Philippe Lang

Fixed: Git blame/annotate fails on moved files (#3832).

Revision 3531 - 2010-03-03 22:15 - Jean-Philippe Lang

Fixes git annotate (#3832).

History

#1 - 2009-09-10 02:47 - Eric Davis

- Affected version (unused) set to devel

What revision of Redmine are you using?

#2 - 2009-09-10 02:55 - Jiongliang Zhang

version: r2845

#3 - 2009-09-10 02:58 - Eric Davis

What if you delete that repository from Redmine and reenter it?  This would purge Redmine's old cache of the repository and refresh it using the latest

git code.

#4 - 2009-09-10 04:22 - Jiongliang Zhang

I tried it, and I also restart mongrel_cluster and apache2, but it happens again. Does it can happen in your system?

#5 - 2009-11-04 16:42 - Bernhard Furtmueller

More or less a "me too", I'm  running version: d5f181f47e9c4a5765c3ae76ad9b0b06cac7186d from github.
I also tried to delete from changes, changesets, changesets_issues whithout success.

Trying the git shellout commands from command line works fine.

And this are the last line seen in production.log

  SQL (0.2ms)   SELECT count(*) AS count_all FROM `versions` WHERE (`versions`.project_id = 1) 

Completed in 176ms (View: 11, DB: 1) | 500 Internal Server Error [https://XXX/redmine-testing/projects/puppet/

repository/revisions/8b5672bdf770072dd54352b1556844f86b4f0e05/annotate/puppet/bin/encrypt-file]

 Could you give advice how to proceed debugging this issue?

#6 - 2009-11-11 14:51 - Bernhard Furtmueller

I think, I could track this down.

When moving a file in the repository, the git blame output changes in a way redmine can't cope with.

[master!test-blame]$ git blame -l e39aadbf021a871d80fbb969d99d36bdb4ed7a7f -- myfirstfile 

e39aadbf021a871d80fbb969d99d36bdb4ed7a7f (Bernhard 2009-11-11 14:53:40 +0100 1) a

[master!test-blame]$ git blame -l bf72277c133f719557929dc86fda529453adf863 -- myfirstmove/myfirstfile 

e39aadbf021a871d80fbb969d99d36bdb4ed7a7f myfirstfile (Bernhard 2009-11-11 14:53:40 +0100 1) a

[master!test-blame]$ 

 See the additional myfirstfile in the 2nd blame output, which refers to the file before the move.

#7 - 2009-11-11 19:19 - Bernhard Furtmueller

- File 0001-switched-to-git-blame-p.patch added

- Assignee set to Eric Davis

I've created a patch which resolves the problem for me, knowing it is far away from clean ruby.

To make parsing simpler I chose to use "git blame -p" which seem to be designed for parsing.

@Jiongliang Zhang: can you verify this is fixed with this patch?

#8 - 2009-11-23 13:00 - Bernhard Furtmueller

- File 0001-switched-git-blame-to-use-the-porcelain-format-p.patch added

updated patch to "blame unless blame.empty?"

#9 - 2009-11-24 08:19 - Bernhard Furtmueller

Since git branch was backported to stable (0.8.7), I also tried it with the latest stable, same problem.

It's really easy to reproduce:

Empty project, empty git repo

add file to repo

move file to a subdirectory

try to annotate the moved file => err 500

For completeness's sake: git version 1.6.5.2

br,

bernhard

PS: Affected version should be set to 0.8.7

#10 - 2009-12-08 15:00 - Arnaud Fontaine

Hello,

I have exactly the same kind of problem:

$ git --git-dir /tmp/test/.git blame l '1609c5d7425d48784ac6e2fe12eb8557c171348e' - 'test.c'

^1609c5d7425d48784ac6e2fe12eb8557c171348 (Arnaud Fontaine 2009-12-08 15:03:13 +0100 1) #include <stdio.h>

The last digit of the Git revision is missing as there is a '^' at the beginning (I don't know why though). Therefore, I think that using `-p' instead of `-l'

would be the way to go. Thanks much for applying the patch submitted by Bernhard.

Regards,
Arnaud Fontaine

#11 - 2009-12-30 00:12 - Lawrence Ferreira

how can I apply this patch?

Thanks

#12 - 2009-12-30 00:15 - Lawrence Ferreira

Nevermind...

I've found the command! thanks for the patch

#13 - 2010-02-28 13:12 - Jean-Philippe Lang

- Subject changed from Git SCM show error to Git blame/annotate fails on moved files

- Status changed from New to Resolved

- Assignee changed from Eric Davis to Jean-Philippe Lang

- Target version set to 0.9.4

- Resolution set to Fixed

Patch committed with slight changes and tests in r3513.

#14 - 2010-03-01 12:12 - Bernhard Furtmueller

Thanks for taking care, but when doing the slightly change there was introduced some consistency error.

in svn annotate in each line the user is prepended

in git annotate now only on 1st occurrence the user is prepended

I think that was also the reason why I used auth as hash.

#15 - 2010-03-03 22:21 - Jean-Philippe Lang

Fixed in r3531.

#16 - 2010-03-05 10:44 - Bernhard Furtmueller

Cherry picked, fix confirmed.

Thanks,

bernhard

#17 - 2010-04-11 16:03 - Jean-Philippe Lang

- Status changed from Resolved to Closed

Files

0001-switched-to-git-blame-p.patch 1.61 KB 2009-11-11 Bernhard Furtmueller

0001-switched-git-blame-to-use-the-porcelain-format-p.patch 1.94 KB 2009-11-23 Bernhard Furtmueller
